Index: src/Actions/SelectionAction/Atoms/InvertAtomsAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/InvertAtomsAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/InvertAtomsAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -17,4 +19,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #undef statetypes
Index: src/Actions/SelectionAction/Atoms/NotAllAtomsAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAllAtomsAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/NotAllAtomsAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -17,4 +19,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::vector<atom*>)
Index: src/Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -46,8 +46,8 @@
 Action::state_ptr SelectionNotAllAtomsInsideCuboidAction::performCall() {
   RealSpaceMatrix RotationMatrix;
-  RotationMatrix.setRotation(params.Xangle, params.Yangle, params.Zangle);
+  RotationMatrix.setRotation(params.Xangle.get(), params.Yangle.get(), params.Zangle.get());
 
-  LOG(1, "Unselecting all atoms inside a rotated " << RotationMatrix << " cuboid at " << params.position << " and extension of " << params.extension << ".");
-  Shape s = translate(transform(stretch(Cuboid(),params.extension),RotationMatrix),params.position);
+  LOG(1, "Unselecting all atoms inside a rotated " << RotationMatrix << " cuboid at " << params.position.get() << " and extension of " << params.extension.get() << ".");
+  Shape s = translate(transform(stretch(Cuboid(),params.extension.get()),RotationMatrix),params.position.get());
   std::vector<atom *> unselectedAtoms = World::getInstance().getAllAtoms((!AtomsBySelection()) && AtomsByShape(s));
   World::getInstance().unselectAllAtoms(AtomsByShape(s));
Index: src/Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -12,12 +12,22 @@
 class Vector;
 
+#include "Parameters/Validators/Specific/BoxVectorValidator.hpp"
+#include "Parameters/Validators/Specific/RotationAngleValidator.hpp"
+#include "Parameters/Validators/Specific/VectorPositiveComponentsValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (Vector)(Vector)(double)(double)(double)
 #define paramtokens ("unselect-atoms-inside-cuboid")("position")("angle-x")("angle-y")("angle-z")
 #define paramdescriptions ("dimension of cuboid")("position in R^3 space")("angle of a rotation around x axis")("angle of a rotation around y axis")("angle of a rotation around z axis")
-#define paramdefaults (NODEFAULT)(NODEFAULT)("0.")("0.")("0.")
+#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))
 #define paramreferences (extension)(position)(Xangle)(Yangle)(Zangle)
+#define paramvalids \
+(VectorPositiveComponentsValidator()) \
+(BoxVectorValidator()) \
+(RotationAngleValidator()) \
+(RotationAngleValidator()) \
+(RotationAngleValidator())
 
 #define statetypes (std::vector<atom*>)(Shape)
Index: src/Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -44,6 +44,6 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionNotAllAtomsInsideSphereAction::performCall() {
-  LOG(1, "Unselecting all atoms inside a sphere at " << params.position << " with radius " << params.radius << ".");
-  Shape s = translate(resize(Sphere(),params.radius),params.position);
+  LOG(1, "Unselecting all atoms inside a sphere at " << params.position.get() << " with radius " << params.radius.get() << ".");
+  Shape s = translate(resize(Sphere(),params.radius.get()),params.position.get());
   std::vector<atom *> unselectedAtoms = World::getInstance().getAllAtoms((!AtomsBySelection()) && AtomsByShape(s));
   World::getInstance().unselectAllAtoms(AtomsByShape(s));
Index: src/Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -10,7 +10,10 @@
 class Vector;
 
+#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
+#include "Parameters/Validators/Specific/BoxVectorValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (double)(Vector)
 #define paramtokens ("unselect-atoms-inside-sphere")("position")
@@ -18,4 +21,7 @@
 #undef paramdefaults
 #define paramreferences (radius)(position)
+#define paramvalids \
+(BoxLengthValidator()) \
+(BoxVectorValidator())
 
 #define statetypes (std::vector<atom*>)(Shape)
Index: src/Actions/SelectionAction/Atoms/NotAllAtomsOfMoleculeAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAllAtomsOfMoleculeAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/NotAllAtomsOfMoleculeAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -17,4 +19,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::vector<atom*>)
Index: src/Actions/SelectionAction/Atoms/NotAtomByElementAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAtomByElementAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/NotAtomByElementAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -41,7 +41,7 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionNotAtomByElementAction::performCall() {
-  LOG(1, "Unselecting atoms of type " << *params.elemental);
+  LOG(1, "Unselecting atoms of type " << *params.elemental.get());
   std::vector<atom *> unselectedAtoms = World::getInstance().getAllAtoms(!AtomsBySelection());
-  World::getInstance().unselectAllAtoms(AtomByType(params.elemental));
+  World::getInstance().unselectAllAtoms(AtomByType(params.elemental.get()));
   LOG(0, World::getInstance().countSelectedAtoms() << " atoms remain selected.");
   return Action::state_ptr(new SelectionNotAtomByElementState(unselectedAtoms,params));
@@ -51,5 +51,5 @@
   SelectionNotAtomByElementState *state = assert_cast<SelectionNotAtomByElementState*>(_state.get());
 
-  World::getInstance().selectAllAtoms(AtomByType(state->params.elemental));
+  World::getInstance().selectAllAtoms(AtomByType(state->params.elemental.get()));
   BOOST_FOREACH(atom *_atom, state->unselectedAtoms)
     World::getInstance().unselectAtom(_atom);
@@ -61,5 +61,5 @@
   SelectionNotAtomByElementState *state = assert_cast<SelectionNotAtomByElementState*>(_state.get());
 
-  World::getInstance().unselectAllAtoms(AtomByType(state->params.elemental));
+  World::getInstance().unselectAllAtoms(AtomByType(state->params.elemental.get()));
 
   return Action::state_ptr(_state);
Index: src/Actions/SelectionAction/Atoms/NotAtomByElementAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAtomByElementAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/NotAtomByElementAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class element;
 
+#include "Parameters/Validators/Specific/ElementValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (const element*)
 #define paramtokens ("unselect-atom-by-element")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (elemental)
+#define paramvalids \
+(ElementValidator())
 
 #define statetypes (std::vector<atom*>)
Index: src/Actions/SelectionAction/Atoms/NotAtomByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAtomByIdAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/NotAtomByIdAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -38,5 +38,5 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionNotAtomByIdAction::performCall() {
-  const atom * Walker = World::getInstance().getAtom(AtomById(params.WalkerId));
+  const atom * Walker = World::getInstance().getAtom(AtomById(params.WalkerId.get()));
   if (Walker != NULL) {
     if (World::getInstance().isSelected(Walker)) {
@@ -56,5 +56,5 @@
   SelectionNotAtomByIdState *state = assert_cast<SelectionNotAtomByIdState*>(_state.get());
 
-  const atom * Walker = World::getInstance().getAtom(AtomById(state->params.WalkerId));
+  const atom * Walker = World::getInstance().getAtom(AtomById(state->params.WalkerId.get()));
   World::getInstance().selectAtom(Walker);
 
@@ -65,5 +65,5 @@
   SelectionNotAtomByIdState *state = assert_cast<SelectionNotAtomByIdState*>(_state.get());
 
-  const atom * Walker = World::getInstance().getAtom(AtomById(state->params.WalkerId));
+  const atom * Walker = World::getInstance().getAtom(AtomById(state->params.WalkerId.get()));
   World::getInstance().unselectAtom(Walker);
 
Index: src/Actions/SelectionAction/Atoms/NotAtomByIdAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAtomByIdAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/NotAtomByIdAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class atom;
 
+#include "Parameters/Validators/Specific/AtomIdValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (atomId_t)
 #define paramtokens ("unselect-atom-by-id")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (WalkerId)
+#define paramvalids \
+(AtomIdValidator())
 
 #undef statetypes
Index: src/Actions/SelectionAction/Atoms/NotAtomByOrderAction.cpp
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAtomByOrderAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/NotAtomByOrderAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -39,5 +39,5 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionNotAtomByOrderAction::performCall() {
-  const atom * Walker = World::getInstance().getAtom(AtomByOrder(params.order));
+  const atom * Walker = World::getInstance().getAtom(AtomByOrder(params.order.get()));
   if (Walker != NULL) {
     if (World::getInstance().isSelected(Walker)) {
Index: src/Actions/SelectionAction/Atoms/NotAtomByOrderAction.def
===================================================================
--- src/Actions/SelectionAction/Atoms/NotAtomByOrderAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Atoms/NotAtomByOrderAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class atom;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (int)
 #define paramtokens ("unselect-atom-by-order")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (order)
+#define paramvalids \
+(DummyValidator< int >())
 
 #define statetypes (atomId_t)
Index: src/Actions/SelectionAction/Molecules/AllMoleculesAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/AllMoleculesAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/AllMoleculesAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -16,4 +18,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::vector<molecule*>)
Index: src/Actions/SelectionAction/Molecules/ClearAllMoleculesAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/ClearAllMoleculesAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/ClearAllMoleculesAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -16,4 +18,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::vector<molecule*>)
Index: src/Actions/SelectionAction/Molecules/InvertMoleculesAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/InvertMoleculesAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/InvertMoleculesAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -16,4 +18,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #undef statetypes
Index: src/Actions/SelectionAction/Molecules/MoleculeByFormulaAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByFormulaAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/MoleculeByFormulaAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -40,11 +40,11 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionMoleculeByFormulaAction::performCall() {
-  LOG(1, "Selecting molecules with chemical formula " << params.formula << ":");
-//  std::vector<molecule *> matchingMolecules = World::getInstance().getAllMolecules(MoleculeByFormula(params.formula));
+  LOG(1, "Selecting molecules with chemical formula " << params.formula.get() << ":");
+//  std::vector<molecule *> matchingMolecules = World::getInstance().getAllMolecules(MoleculeByFormula(params.formula.get()));
   std::vector<molecule *> selectedMolecules =
-      World::getInstance().getAllMolecules(MoleculesBySelection() && MoleculeByFormula(params.formula));
+      World::getInstance().getAllMolecules(MoleculesBySelection() && MoleculeByFormula(params.formula.get()));
 //  BOOST_FOREACH(molecule *mol, matchingMolecules)
 //    LOG(1, "\t" << mol->getId() << ", " << mol->getName() << ".");
-  World::getInstance().selectAllMolecules(MoleculeByFormula(params.formula));
+  World::getInstance().selectAllMolecules(MoleculeByFormula(params.formula.get()));
   LOG(0, World::getInstance().countSelectedMolecules() << " molecules selected.");
   return Action::state_ptr(new SelectionMoleculeByFormulaState(selectedMolecules,params));
@@ -54,5 +54,5 @@
   SelectionMoleculeByFormulaState *state = assert_cast<SelectionMoleculeByFormulaState*>(_state.get());
 
-  World::getInstance().unselectAllMolecules(MoleculeByFormula(state->params.formula));
+  World::getInstance().unselectAllMolecules(MoleculeByFormula(state->params.formula.get()));
   BOOST_FOREACH( molecule *mol, state->selectedMolecules)
     World::getInstance().selectMolecule(mol);
@@ -64,5 +64,5 @@
   SelectionMoleculeByFormulaState *state = assert_cast<SelectionMoleculeByFormulaState*>(_state.get());
 
-  World::getInstance().selectAllMolecules(MoleculeByFormula(state->params.formula));
+  World::getInstance().selectAllMolecules(MoleculeByFormula(state->params.formula.get()));
 
   return Action::state_ptr(_state);
Index: src/Actions/SelectionAction/Molecules/MoleculeByFormulaAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByFormulaAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/MoleculeByFormulaAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class molecule;
 
+#include "Parameters/Validators/Specific/FormulaValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (std::string)
 #define paramtokens ("select-molecules-by-formula")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (formula)
+#define paramvalids \
+(FormulaValidator())
 
 #define statetypes (std::vector<molecule*>)
Index: src/Actions/SelectionAction/Molecules/MoleculeByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByIdAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/MoleculeByIdAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -38,9 +38,9 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionMoleculeByIdAction::performCall() {
-  const molecule *mol = World::getInstance().getMolecule(MoleculeById(params.molindex));
+  const molecule *mol = World::getInstance().getMolecule(MoleculeById(params.molindex.get()));
   if (mol != NULL) {
     if (!World::getInstance().isSelected(mol)) {
       LOG(1, "Selecting molecule " << mol->name);
-      World::getInstance().selectAllMolecules(MoleculeById(params.molindex));
+      World::getInstance().selectAllMolecules(MoleculeById(params.molindex.get()));
       LOG(0, World::getInstance().countSelectedMolecules() << " molecules selected.");
       return Action::state_ptr(new SelectionMoleculeByIdState(params));
@@ -56,5 +56,5 @@
   SelectionMoleculeByIdState *state = assert_cast<SelectionMoleculeByIdState*>(_state.get());
 
-  World::getInstance().unselectAllMolecules(MoleculeById(state->params.molindex));
+  World::getInstance().unselectAllMolecules(MoleculeById(state->params.molindex.get()));
 
   return Action::state_ptr(_state);
@@ -64,5 +64,5 @@
   SelectionMoleculeByIdState *state = assert_cast<SelectionMoleculeByIdState*>(_state.get());
 
-  World::getInstance().selectAllMolecules(MoleculeById(state->params.molindex));
+  World::getInstance().selectAllMolecules(MoleculeById(state->params.molindex.get()));
 
   return Action::state_ptr(_state);
Index: src/Actions/SelectionAction/Molecules/MoleculeByIdAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByIdAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/MoleculeByIdAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -7,13 +7,18 @@
 
 // all includes and forward declarations necessary for non-integral types below
+#include "types.hpp"
+
+#include "Parameters/Validators/Specific/MoleculeIdValidator.hpp"
 
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (int)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (moleculeId_t)
 #define paramtokens ("select-molecule-by-id")
 #define paramdescriptions ("molecule index")
 #undef paramdefaults
 #define paramreferences (molindex)
+#define paramvalids \
+(MoleculeIdValidator())
 
 #undef statetypes
Index: src/Actions/SelectionAction/Molecules/MoleculeByNameAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByNameAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/MoleculeByNameAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -40,8 +40,8 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionMoleculeByNameAction::performCall() {
-  LOG(1, "Selecting all molecules called " << params.molname);
+  LOG(1, "Selecting all molecules called " << params.molname.get());
   std::vector<molecule *> selectedMolecules =
-      World::getInstance().getAllMolecules(MoleculesBySelection() && MoleculeByName(params.molname));
-  World::getInstance().selectAllMolecules(MoleculeByName(params.molname));
+      World::getInstance().getAllMolecules(MoleculesBySelection() && MoleculeByName(params.molname.get()));
+  World::getInstance().selectAllMolecules(MoleculeByName(params.molname.get()));
   LOG(0, World::getInstance().countSelectedMolecules() << " molecules selected.");
 
@@ -52,5 +52,5 @@
   SelectionMoleculeByNameState *state = assert_cast<SelectionMoleculeByNameState*>(_state.get());
 
-  World::getInstance().unselectAllMolecules(MoleculeByName(state->params.molname));
+  World::getInstance().unselectAllMolecules(MoleculeByName(state->params.molname.get()));
   BOOST_FOREACH( molecule *mol, state->selectedMolecules)
     World::getInstance().selectMolecule(mol);
@@ -62,5 +62,5 @@
   SelectionMoleculeByNameState *state = assert_cast<SelectionMoleculeByNameState*>(_state.get());
 
-  World::getInstance().selectAllMolecules(MoleculeByName(state->params.molname));
+  World::getInstance().selectAllMolecules(MoleculeByName(state->params.molname.get()));
 
   return Action::state_ptr(_state);
Index: src/Actions/SelectionAction/Molecules/MoleculeByNameAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByNameAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/MoleculeByNameAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -11,7 +11,9 @@
 class molecule;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (std::string)
 #define paramtokens ("select-molecules-by-name")
@@ -19,4 +21,6 @@
 #undef paramdefaults
 #define paramreferences (molname)
+#define paramvalids \
+(DummyValidator< std::string >())
 
 #define statetypes (std::vector<molecule *>)
Index: src/Actions/SelectionAction/Molecules/MoleculeByOrderAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByOrderAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/MoleculeByOrderAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -39,5 +39,5 @@
 
 Action::state_ptr SelectionMoleculeByOrderAction::performCall() {
-  molecule *mol = World::getInstance().getMolecule(MoleculeByOrder(params.molindex));
+  molecule *mol = World::getInstance().getMolecule(MoleculeByOrder(params.molindex.get()));
 
   if (mol != NULL) {
Index: src/Actions/SelectionAction/Molecules/MoleculeByOrderAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByOrderAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/MoleculeByOrderAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class molecule;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (int)
 #define paramtokens ("select-molecule-by-order")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (molindex)
+#define paramvalids \
+(DummyValidator< int >())
 
 #define statetypes (const molecule *)
Index: src/Actions/SelectionAction/Molecules/MoleculeOfAtomAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeOfAtomAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/MoleculeOfAtomAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -16,4 +18,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::vector<molecule*>)
Index: src/Actions/SelectionAction/Molecules/NotAllMoleculesAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/NotAllMoleculesAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/NotAllMoleculesAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -16,4 +18,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::vector<molecule*>)
